%define major		1
%define libname		%mklibname %{name} %{major}
%define dlibname	%mklibname %{name} -d
%define libacpicaname	%mklibname %{name}acpica %{major}
%define dlibacpicaname	%mklibname %{name}acpica -d
%define libsiaslname	%mklibname %{name}iasl %{major}
%define dlibsiaslname	%mklibname %{name}iasl -d

Name:		fwts
Version:	24.09.00
Release:	%mkrel 1
Summary:	Firmware Test Suite
License:	GPLv2+
Group:		System/Base
URL:		https://wiki.ubuntu.com/FirmwareTestSuite
Source:		https://fwts.ubuntu.com/release/%{name}-V%{version}.tar.gz
Patch0:		compile.mga.patch
Patch1:		fwts-autoconf.patch
Patch2:		fwts-fix-build-with-gcc15.patch
BuildRequires:	autoconf
BuildRequires:	automake
BuildRequires:	libtool
BuildRequires:	flex
BuildRequires:	bison
BuildRequires:	mt-st
BuildRequires:	pkgconfig(json-c)
BuildRequires:	pkgconfig(glib-2.0)
BuildRequires:	pkgconfig(libbsd)

#Requires:	pciutils,dmidecode

%description
The tool fwts comprises of over fifty tests that are designed to exercise
and test different aspects of a machine's firmware.
(The fwts-efi-runtime-dkms package is dkms managed)
#--------------------------------------------------------------------

%package -n	%{libsiaslname}
Group:		System/Libraries
Summary:	FirmWare Test Suite ACPICA core built for iasl functionality

%description -n	%{libsiaslname}
The firmware test suite requires the ACPICA core engine to be built in compiler
mode (with ACPI_ASL_COMPILER enabled) to support assembly and disassembly of
ACPI Machine Language (AML) in the ACPI DSDT and SSDTs.
This library contains this code with a thin fwts specific API to interface with fwts.

%package -n	%{dlibsiaslname}
Group:		Development/C
Summary:	Devel libraries and headers for FirmWare Test Suite ACPICA core built for iasl functionality
Requires:	%{libsiaslname} = %{version}-%{release}
Requires:	%{dlibname} = %{version}-%{release}
Provides:	%{name}iasl-devel = %{version}-%{release}
Provides:	lib%{name}iasl-devel = %{version}-%{release}

%description -n	%{dlibsiaslname}
The firmware test suite requires the ACPICA core engine to be built in compiler
mode (with ACPI_ASL_COMPILER enabled) to support assembly and disassembly of
ACPI Machine Language (AML) in the ACPI DSDT and SSDTs.
This library contains this code with a thin fwts specific API to interface with
fwts and provides Devel libraries and headers.

%package -n	%{libacpicaname}
Group:		System/Libraries
Summary:	FirmWare Test Suite ACPICA core built for acpiexec functionality

%description -n	%{libacpicaname}
The firmware test suite requires the ACPICA core engine to be built in execution
mode (with ACPI_EXEC_APP enabled) to support run time execution of ACPI Machine
Language (AML) in the ACPI DSDT and SSDTs. This library contains this code with
a thin fwts specific API to interface with fwts.

%package -n	%{dlibacpicaname}
Group:		Development/C
Summary:	Devel libraries and headers for FirmWare Test Suite ACPICA core built for acpiexec functionality
Requires:	%{libacpicaname} = %{version}-%{release}
Requires:	%{dlibname} = %{version}-%{release}
Provides:	%{name}acpica-devel = %{version}-%{release}
Provides:	lib%{name}acpica-devel = %{version}-%{release}

%description -n	%{dlibacpicaname}
The firmware test suite requires the ACPICA core engine to be built in execution
mode (with ACPI_EXEC_APP enabled) to support run time execution of ACPI Machine
Language (AML) in the ACPI DSDT and SSDTs. This library contains this code with
a thin fwts specific API to interface with fwts and provides Devel libraries
and headers.

%package -n	%{libname}
Group:		System/Libraries
Summary:	FirmWare Test Suite core support library

%description -n	%{libname}
This is the fwts core library. It contains a top level test framework and a rich
range of firmware specific testing support code for the various fwts tests.

%package -n	%{dlibname}
Group:		Development/C
Summary:	Devel libraries and headers for FirmWare Test Suite core support library
Requires:	%{libname} = %{version}-%{release}
Provides:	%{name}-devel = %{version}-%{release}
Provides:	lib%{name}-devel = %{version}-%{release}

Obsoletes:	%{_lib}fwts1-devel < 15.01.00-2

%description -n	%{dlibname}
This is the fwts core library. It contains a top level test framework and a rich
range of firmware specific testing support code for the various fwts tests and
provides Devel libraries and headers.

#package -n	%%{name}-frontend
#Requires:	fwts,dialog
#Group:		Development/C
#Summary:	Firmware Test Suite frontend interface

#description -n	%%{name}-frontend
#This is a dialog based interface designed to provide an easy to use method to
#execute tests via Firmware Test Suite and is also used as the primary interface
#within Firmware Test Suite live images.

%package -n	%{name}-efi-runtime-dkms
Requires:	dkms
Group:		Development/C
Summary:	Firmware Test Suite frontend interface

%description -n	%{name}-efi-runtime-dkms
This is a dialog based interface designed to provide an easy to use method to
execute tests via Firmware Test Suite and is also used as the primary interface
within Firmware Test Suite live images.

%prep
%setup -q -c -n %{name}-%{version}
#autopatch -p1
%patch -P 2 -p1

# Mageia json includes are in another subdir
# Not done as a patch to allow for changes upstream
find . -name '*.c' -o -name '*.h' | xargs perl -pi -e 's|#include <json/json.h>|#include <json-c/json.h>|'
perl -pi -e 's|json/json.h|json-c/json.h|' configure.ac
perl -pi -e 's|<json.h>|<json-c/json.h>|' src/lib/include/fwts_json.h src/utilities/kernelscan.c

%build
%define _disable_ld_no_undefined 1
export DESTDIR=%{_prefix}

autoreconf -ivf
# Do not use %%configure macros here it breaks the build
#./configure
./configure --prefix=%{_prefix} --libdir=%{_libdir} --disable-static
%__make

%install
%make_install

find %{buildroot} -type f -name "*.la" -print -delete
#install -D -m 0644 data/klog.json %%{buildroot}%%{_datadir}/%%{name}/klog.json
#install -D -m 0644 data/syntaxcheck.json %%{buildroot}%%{_datadir}/%%{name}/syntaxcheck.json
mkdir -p %{buildroot}%{_usrsrc}/%{name}-efi-runtime-dkms-%{version}
cp -a efi_runtime/* %{buildroot}%{_usrsrc}/%{name}-efi-runtime-dkms-%{version}
cp debian/fwts-efi-runtime-dkms.dkms %{buildroot}%{_usrsrc}/%{name}-efi-runtime-dkms-%{version}/dkms.conf
# lib are delivered in a subdir by default
mv %{buildroot}%{_libdir}/%{name}/* %{buildroot}/%{_libdir}
rmdir %{buildroot}%{_libdir}/%{name}
# we don't deliver frontend for now
rm -f %{buildroot}%{_mandir}/man1/%{name}-frontend-text.*
mkdir -p %{buildroot}%{_includedir}
mv src/lib/include/*.h %{buildroot}%{_includedir}

%post -n %{name}-efi-runtime-dkms
dkms add -m %{name}-efi-runtime-dkms -v %{version} --rpm_safe_upgrade
dkms build -m %{name}-efi-runtime-dkms -v %{version} --rpm_safe_upgrade &&
dkms install -m %{name}-efi-runtime-dkms -v %{version} --rpm_safe_upgrade --force
true

%preun -n %{name}-efi-runtime-dkms
dkms remove -m %{name}-efi-runtime-dkms -v %{version} --all --rpm_safe_upgrade
true

%files
%doc README*
%dir %{_datadir}/%{name}
%{_datadir}/%{name}/*.json
%{_bindir}/%{name}
%{_bindir}/kernelscan
%{_mandir}/man1/%{name}.1.*
%{_mandir}/man1/%{name}-collect.1.*
%{_datadir}/bash-completion/completions/%{name}

%files -n %{libname}
%{_libdir}/lib%{name}.so.%{major}
%{_libdir}/lib%{name}.so.%{major}.*

%files -n %{dlibname}
%{_includedir}/fwts*.h
%{_libdir}/lib%{name}.so

%files -n %{libsiaslname}
%{_libdir}/lib%{name}iasl.so.%{major}
%{_libdir}/lib%{name}iasl.so.%{major}.*

%files -n %{dlibsiaslname}
%{_libdir}/lib%{name}iasl.so

%files -n %{libacpicaname}
%{_libdir}/lib%{name}acpica.so.%{major}
%{_libdir}/lib%{name}acpica.so.%{major}.*

%files -n %{dlibacpicaname}
%{_libdir}/lib%{name}acpica.so

#files -n %%{name}-frontend
#{_bindir}/%%{name}-frontend-text
#{_datadir}/%%{name}/fwts-live-dialogrc
#{_mandir}/man1/%%{name}-frontend-text.1.*

%files -n %{name}-efi-runtime-dkms
%{_usrsrc}/%{name}-efi-runtime-dkms-%{version}


%changelog
* Tue May 13 2025 ns80 <ns80> 24.09.00-1.mga10
+ Revision: 2183206
- try to fix building with GCC 15
- new version 24.09.00

* Tue Aug 27 2024 neoclust <neoclust> 24.03.00-1.mga10
+ Revision: 2091703
- New version 24.03.00

* Sun Apr 16 2023 daviddavid <daviddavid> 22.11.00-3.mga9
+ Revision: 1953238
- remove no more needed old pcre-devel build dependency

* Wed Dec 21 2022 daviddavid <daviddavid> 22.11.00-2.mga9
+ Revision: 1925598
- rebuild for new libbsd 0.11.7

* Tue Nov 22 2022 bcornec <bcornec> 22.11.00-1.mga9
+ Revision: 1910026
- Update to upstream fwts 22.11

* Wed Mar 30 2022 umeabot <umeabot> 21.09.00-4.mga9
+ Revision: 1834071
- Mageia 9 Mass Rebuild
+ bcornec <bcornec>
- update to upstream fwts 21.09.00

* Sun Nov 29 2020 luigiwalser <luigiwalser> 20.08.00-3.mga8
+ Revision: 1650336
- rebuild for json-c

* Tue Nov 10 2020 wally <wally> 20.08.00-2.mga8
+ Revision: 1644293
- fix build with autoconf 2.69d

* Tue Aug 25 2020 bcornec <bcornec> 20.08.00-1.mga8
+ Revision: 1618988
- Update to upstream 20.08.00

* Mon Aug 24 2020 bcornec <bcornec> 20.07.00-1.mga8
+ Revision: 1618580
- Also remove -Werrors calls in remaining Makefile.am
- Fix configure to not generate -Werrors flag for now
- Do not consider warnings as errors for now for fwts
- Fix build now that bison is generating y.tab.c files systematically
- Update fwts to upstream V20.07.00

* Sat Feb 15 2020 umeabot <umeabot> 19.03.00-2.mga8
+ Revision: 1524872
- Mageia 8 Mass Rebuild
+ wally <wally>
- replace deprecated %%configure2_5x

* Mon Apr 01 2019 bcornec <bcornec> 19.03.00-1.mga7
+ Revision: 1383972
- update to upstream fwts 19.03

* Tue Jan 01 2019 bcornec <bcornec> 18.12.00-1.mga7
+ Revision: 1348412
- Update to upstream fwts 18.12.00

* Tue Sep 25 2018 umeabot <umeabot> 18.06.02-3.mga7
+ Revision: 1304367
- Mageia 7 Mass Rebuild

* Thu Jul 26 2018 daviddavid <daviddavid> 18.06.02-2.mga7
+ Revision: 1245367
- rebuild for new json-c 0.13.1

* Tue Jun 26 2018 bcornec <bcornec> 18.06.02-1.mga7
+ Revision: 1239940
- Update to ustream 18.06.02 fwts

* Thu Jun 22 2017 bcornec <bcornec> 17.06.00-1.mga6
+ Revision: 1108156
- Update to upstream 17.06

* Mon Jan 02 2017 bcornec <bcornec> 16.12.00-1.mga6
+ Revision: 1079631
- update to upstream fwts 16.12.00

* Sat Sep 24 2016 bcornec <bcornec> 16.09.00-1.mga6
+ Revision: 1055671
- Update to fwts 16.09.00 upstream

* Fri Aug 26 2016 bcornec <bcornec> 16.08.01-1.mga6
+ Revision: 1048961
- Update to upstream fwts 16.08.01

* Tue Aug 16 2016 bcornec <bcornec> 16.07.00-1.mga6
+ Revision: 1046557
- Update to upstream fwts 16.07.00

* Thu May 26 2016 bcornec <bcornec> 16.05.01-1.mga6
+ Revision: 1018849
- Update to fwts upstream 16.05.01 - minor release

* Mon May 23 2016 bcornec <bcornec> 16.05.00-1.mga6
+ Revision: 1018025
- Update to upstream 16.05.00

* Sat Feb 27 2016 bcornec <bcornec> 16.02.00-1.mga6
+ Revision: 979792
- Update to upstream fwts 16.02.00

* Thu Jan 14 2016 bcornec <bcornec> 16.01.00-1.mga6
+ Revision: 922983
- Update to upstream fwts 16.01.00

* Tue Dec 29 2015 bcornec <bcornec> 15.12.00-2.mga6
+ Revision: 916778
- Fix bug 17363

* Mon Nov 16 2015 bcornec <bcornec> 15.11.00-1.mga6
+ Revision: 903589
- Update to upstream fwts 15.11.00

* Tue Sep 15 2015 bcornec <bcornec> 15.09.00-1.mga6
+ Revision: 879697
- Update to upstream fwts 15.09.00

* Mon Jul 13 2015 bcornec <bcornec> 15.07.00-1.mga6
+ Revision: 853461
- Update to upstream 15.07.00

* Thu Jan 29 2015 bcornec <bcornec> 15.01.00-2.mga6
+ Revision: 812690
- Apply patch from David GEIGER <geiger.david68210_at_gmail.com> to fix libraries management

* Sat Jan 24 2015 bcornec <bcornec> 15.01.00-1.mga5
+ Revision: 812147
- Update to upstream 15.00.01
- Update sha1 file as well :-(
- Updated to upstream 14.12.00

* Sat Nov 22 2014 bcornec <bcornec> 14.11.00-1.mga5
+ Revision: 798252
- Update to upstream 14.11.00

* Wed Oct 15 2014 umeabot <umeabot> 14.09.00-2.mga5
+ Revision: 741132
- Second Mageia 5 Mass Rebuild

* Wed Sep 24 2014 bcornec <bcornec> 14.09.00-1.mga5
+ Revision: 723682
- update to upstream 14.09.00

* Tue Sep 16 2014 umeabot <umeabot> 14.08.00-2.mga5
+ Revision: 679391
- Mageia 5 Mass Rebuild

* Thu Sep 11 2014 bcornec <bcornec> 14.08.00-1.mga5
+ Revision: 674689
- Improv build and install requires
- Fix a description missing for the main pkg
- Adds a missing sha1
- Import fwts inspired by the debian pkg
- Created package structure for fwts.

